package benchmarks;

import java.io.InputStream;

import seppImpl.DegreeAnonymizer2;
import seppImpl.GraphRealizer;
import de.vibee.kanon.data.AdjacentGraph;
import de.vibee.kanon.tools.Reader;

public class PubliMain
{
	public static void main(String[] args)
	{
		MainTest.timeStamp = System.currentTimeMillis();

		MainTest.logLevel=0;
		DegreeAnonymizer2.logDR=0;
		GraphRealizer.log=0;

		String filePath = args[0];
		final Reader reader = new Reader(filePath);
		final AdjacentGraph graph = reader.readInputGraphAlternateFormat();

		int k = Integer.parseInt(args[1]);
		
		System.out.println("file:"+filePath+"\t,k="+k);
		TestHeuristic heuristicTester = new TestHeuristic(graph, k);
		heuristicTester.start();

		try
		{
			heuristicTester.join(1000 * 60 * 60);
		} catch (InterruptedException e1)
		{
		}
		if ( heuristicTester.isAlive() )
		{
			System.out.print("\t\tUBheuristic aborted");
			heuristicTester.interrupt();
			heuristicTester.stop();
		}
		System.gc();

		final TestAnonymizerCaller s = new TestAnonymizerCaller(graph, k, true);
		s.start();
		try
		{
			s.join(1000 * 60 * 60);

		} catch (final InterruptedException e)
		{

		}
		System.out.print(s.output);
		if ( s.isAlive() )
		{
			for (int tmp = s.output.split("\t").length; tmp <= 8; tmp++)
				System.out.print("\t");
			s.interrupt();
			s.stop();

			System.out.print("aborted,\t#testRealSol:" + s.testedToRealizeSolutions);
			if ( s.anonymizer != null )
			{
				System.out.print("\t lastCostValue:" + (s.anonymizer.lastExaminedCost + s.anonymizer.preprocessCost));
				System.out.print("\t, lastUpperBoundInSolutionIterator:" + s.anonymizer.solutionDegreeIterator.getCurrentUpperbound());
			}
		}
		System.out.println();
		System.out.flush();
		System.gc();
	}
}
