package benchmarks;

import gnu.trove.set.TIntSet;
import gnu.trove.set.hash.TIntHashSet;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.Vector;

import seppImpl.CannotRealize;
import seppImpl.CompactDegreeSequence;
import seppImpl.DegreeAnonymizer2;
import seppImpl.GraphRealizer;
import de.vibee.kanon.data.AdjacentGraph;
import de.vibee.kanon.data.DegreeSequence;
import de.vibee.kanon.tools.Reader;

public class TestRealizer
{

	private static int real = 0;

	private static int total = 0;

	private static double time = 0d;

	public static void addEdge(final List<TIntSet> adjacentList, final int a, final int b)
	{
		adjacentList.get(a).add(b);
		adjacentList.get(b).add(a);
	}

	public static AdjacentGraph getGraph()
	{
		final List<TIntSet> adjacentList = new ArrayList<>();

		adjacentList.add(null);
		for (int i = 1; i <= 26; i++)
		{
			adjacentList.add(new TIntHashSet());
		}

		for (int i = 1; i <= 9; i++)
		{
			TestRealizer.addEdge(adjacentList, i, 26);
		}

		for (int i = 10; i <= 13; i++)
		{
			TestRealizer.addEdge(adjacentList, i, 24);
		}
		for (int i = 14; i <= 17; i++)
		{
			TestRealizer.addEdge(adjacentList, i, 25);
		}

		TestRealizer.addEdge(adjacentList, 18, 19);
		TestRealizer.addEdge(adjacentList, 18, 20);
		TestRealizer.addEdge(adjacentList, 19, 20);

		TestRealizer.addEdge(adjacentList, 18, 21);
		TestRealizer.addEdge(adjacentList, 19, 22);
		TestRealizer.addEdge(adjacentList, 20, 23);

		TestRealizer.addEdge(adjacentList, 21, 23);
		TestRealizer.addEdge(adjacentList, 22, 23);

		TestRealizer.addEdge(adjacentList, 21, 24);
		TestRealizer.addEdge(adjacentList, 21, 25);
		TestRealizer.addEdge(adjacentList, 22, 24);
		TestRealizer.addEdge(adjacentList, 22, 25);
		TestRealizer.addEdge(adjacentList, 23, 24);
		TestRealizer.addEdge(adjacentList, 23, 25);

		// addEdge(adjacentList,24,25);

		final AdjacentGraph graph = new AdjacentGraph(adjacentList);
		return graph;
	}

	public static AdjacentGraph getGraph2()
	{
		final List<TIntSet> adjacentList = new ArrayList<>();

		adjacentList.add(null);
		for (int i = 1; i <= 3; i++)
		{
			adjacentList.add(new TIntHashSet());
		}
		TestRealizer.addEdge(adjacentList, 1, 2);

		final AdjacentGraph graph = new AdjacentGraph(adjacentList);
		return graph;
	}

	// /**
	// * @param args
	// * @throws Exception
	// */
	// public static void main(final String[] args) throws Exception
	// {
	// GraphRealizer.log = 0;
	// boolean[] bol = { true, false };
	// // for (GraphRealizer.innerIteration = 10; GraphRealizer.innerIteration
	// // <= 1000;
	// // GraphRealizer.innerIteration *= 10)
	// for (GraphRealizer.innerIteration = 25; GraphRealizer.innerIteration <= 100;
	// GraphRealizer.innerIteration += 25)
	// for (GraphRealizer.outerIter = 50; GraphRealizer.outerIter <= 200; GraphRealizer.outerIter +=
	// 50)
	// for (GraphRealizer.sortVerticesRealize = 0; GraphRealizer.sortVerticesRealize <= 2;
	// GraphRealizer.sortVerticesRealize++)
	// {
	// // for (GraphRealizer.outerIter = 10;
	// // GraphRealizer.outerIter <=
	// // 1000;
	// // GraphRealizer.outerIter *= 10)
	//
	// for (GraphRealizer.shuffleMapping = 0; GraphRealizer.shuffleMapping <= 3;
	// GraphRealizer.shuffleMapping++)
	// {
	// System.out.print("innerIter:" + GraphRealizer.innerIteration);
	// System.out.print(",\touterIter:" + GraphRealizer.outerIter);
	// System.out.print(",\tshuffleMapping:" + GraphRealizer.shuffleMapping);
	// System.out.print(",\tsort:" + GraphRealizer.sortVerticesRealize);
	// time = 0d;
	// real = 0;
	// total = 0;
	//
	// final String folder = "graphs/testRealizer/";
	// final String fileList[] = new File(folder).list();
	// Arrays.sort(fileList);
	// for (final String fileName : fileList)
	// {
	// InputStream fis = null;
	// fis = new FileInputStream(folder + fileName);
	// final ObjectInputStream o = new ObjectInputStream(fis);
	// final AdjacentGraph graph = (AdjacentGraph) o.readObject();
	//
	// // final AdjacentGraph graph = getGraph();
	// // Set<CompactDegreeSequence> s = new
	// // DegreeAnonymizer2(graph,
	// // 2,
	// // true,
	// // false).getAllkAnonRealSequences();
	//
	// final CompactDegreeSequence finalSequence = (CompactDegreeSequence) o.readObject();
	// final Vector<CompactDegreeSequence> s = new Vector<CompactDegreeSequence>();
	// s.add(finalSequence);
	// o.close();
	//
	// TestRealizer.testNewRealizer(graph, s);
	// }
	//
	// System.out.println(",\t" + real + "/" + total + "\t(" + time + "s)");
	// }
	// }
	//
	// }

	/**
	 * @param args
	 * @throws Exception
	 */
	public static void main(final String[] args) throws Exception
	{
		GraphRealizer.log = 0;
		for (int t = 0; t <= 1; t++)
		{
			final String folder = "graphs/";
			String fileName = "coAuthorsCiteseer.graph";
			Reader read = new Reader(folder + fileName);
			AdjacentGraph graph = read.readInputGraphAlternateFormat();
			final DegreeAnonymizer2 anonymizer = new DegreeAnonymizer2(graph, 2, true, true);
			final Set<CompactDegreeSequence> allkAnonRealSequences = anonymizer.getAllkAnonRealSequences();
			Vector<CompactDegreeSequence> partAnonRealSequences = new Vector<>();
			Iterator<CompactDegreeSequence> iter = allkAnonRealSequences.iterator();
			int i = 0;
			while (iter.hasNext() && i++ < 10000)
				partAnonRealSequences.add(iter.next());

			for (int innerIteration = 25; innerIteration <= 100; innerIteration += 25)
				for (int outerIter = 50; outerIter <= 200; outerIter += 50)
					for (GraphRealizer.sortVerticesRealize = 0; GraphRealizer.sortVerticesRealize <= 2; GraphRealizer.sortVerticesRealize++)
					{
						for (GraphRealizer.shuffleMapping = 0; GraphRealizer.shuffleMapping <= 3; GraphRealizer.shuffleMapping++)
						{
							System.out.print("innerIter:" + innerIteration);
							System.out.print(",\touterIter:" + outerIter);
							System.out.print(",\tshuffleMapping:" + GraphRealizer.shuffleMapping);
							System.out.print(",\tsort:" + GraphRealizer.sortVerticesRealize);
							time = 0d;
							real = 0;
							total = 0;

							for (final CompactDegreeSequence solution : partAnonRealSequences)
							{
								long t1 = System.currentTimeMillis();
								try
								{
									TestRealizer.total++;

									final GraphRealizer graphRealize = new GraphRealizer(graph, new CompactDegreeSequence(
											DegreeSequence.calcDegreeSequence(graph)), solution, 100, innerIteration, outerIter);
									graphRealize.constructGraph();
									TestRealizer.real++;
								} catch (final Exception e)
								{
								}
								TestRealizer.time += (System.currentTimeMillis() - t1) / 1000d;
							}

							System.out.println(",\t" + real + "/" + total + "\t(" + time + "s)");
						}
					}
		}
	}

}
