package benchmarks;


import seppImpl.DegreeAnonymizer2;
import de.vibee.kanon.data.AdjacentGraph;
import de.vibee.kanon.tools.Reader;

public class TestforKolja
{
	static class NodeDegree implements Comparable<NodeDegree>
	{
		int vertex;

		int degree;

		public NodeDegree(int vertex, int degree)
		{
			this.vertex = vertex;
			this.degree = degree;
		}

		// flipped for descending order
		@Override
		public int compareTo(NodeDegree o)
		{
			if ( this.degree > o.degree )
				return -1;
			else if ( this.degree < o.degree )
				return 1;
			return 0;
		}

		@Override
		public String toString()
		{
			return "NodeDegree [vertex=" + this.vertex + ", degree=" + this.degree + "]";
		}
	}

	public static enum Heuristic { FORWARD, BACKWARD, RANDOM };

	public static void main(String[] args)
	{
//		final AdjacentGraph graph = TestRealizer.getGraph();
		final Reader reader = new Reader("graphs/coAuthorsDBLP.graph");
		final AdjacentGraph graph = reader.readInputGraphAlternateFormat();
		
		final FKDA fkda = new FKDA();
		// result as Set<IntTupel> (kanten welche hinzugefügt werden, falls nicht möglich
		// CannotRealize exception)
		int minSolutionToAnonymizeNumbers;
		int res;
		// res = fkda.fkda(graph, 2).size();
		// System.out.println(res);
		for (int k = 1; k < 25; k++)
		{
			System.out.println("k: " + k);
//			minSolutionToAnonymizeNumbers = new DegreeAnonymizer2(graph, k).getSizeOfMinimumSolution();
			minSolutionToAnonymizeNumbers = 0; //(int) (0.5 * minSolutionToAnonymizeNumbers); // convert degree changes in no of edges
			minSolutionToAnonymizeNumbers /= 2;
			System.out.println("min solution: " + minSolutionToAnonymizeNumbers);
			res = fkda.fkda(graph, k, Heuristic.RANDOM).size();
			// gibt die Moeglichkeit via fkda.set_trials(t); die Anzahl der Versuche fuer die RANDOM Heuristik zu setzen (default = #Knoten)
			System.out.println("fdka solution: " + res);
			if ( minSolutionToAnonymizeNumbers > res )
			{
				System.out.println("bei k: " + k + " fkda kleinere loesung");
			}
			System.out.println("-------");
		}

	}

}
