package de.vibee.kanon.data;

import gnu.trove.iterator.TIntIterator;
import gnu.trove.list.TIntList;
import gnu.trove.list.array.TIntArrayList;
import gnu.trove.set.TIntSet;

public class ComplementGraph
{

	private final AdjacentGraph originalGraph;

	public ComplementGraph(final AdjacentGraph originalGraph)
	{
		this.originalGraph = originalGraph;

	}

	public TIntList getAdjacentNodes(final int node)
	{
		final TIntList adjacentNodes = new TIntArrayList();

		final TIntSet originalNodes = this.originalGraph.getAdjacentNodes(node);
		int index = 1;
		final TIntIterator it = originalNodes.iterator();
		while (it.hasNext())
		{
			final int i = it.next();
			for (int j = index; j < i; j++)
			{
				if ( j != node )
				{
					adjacentNodes.add(j);
				}
			}
			index = i + 1;
		}

		for (int i = index; i < this.getSize(); i++)
		{
			adjacentNodes.add(i);
		}

		return adjacentNodes;
	}

	public int getDegree(final int node)
	{
		return this.originalGraph.getAmountOfVertices() - this.originalGraph.getDegree(node);
	}

	public int getSize()
	{
		return this.originalGraph.getAmountOfVertices();
	}

	public boolean isAdjacent(final int node1, final int node2)
	{
		return !this.originalGraph.isAdjacent(node1, node2);
	}

}
