package de.vibee.kanon.data;

public class IntTupel implements Comparable<IntTupel>
{
	private final int first;

	private final int second;

	private final int hash;

	public IntTupel(final int first, final int second)
	{
		this.first = Math.min(first, second);
		this.second = Math.max(first, second);
		hash = 7 * this.first + 31 * this.second;
	}

	@Override
	public IntTupel clone()
	{
		return new IntTupel(this.getFirst(), this.getSecond());

	}

	@Override
	public int compareTo(final IntTupel o)
	{
		return o.getSecond() - this.getSecond();
	}

	@Override
	public boolean equals(final Object obj)
	{
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (this.getClass() != obj.getClass())
			return false;

		final IntTupel t = (IntTupel) obj;
		return t.first == this.first && t.second == this.second;
	}

	public int getFirst()
	{
		return this.first;
	}

	public int getSecond()
	{
		return this.second;
	}

	@Override
	public int hashCode()
	{

		return hash;
	}

	@Override
	public String toString()
	{
		return "(" + this.first + "-" + this.second + ")";
	}

}
