package de.vibee.kanon.data;

public class ModifyListEntry implements Cloneable
{

	private final boolean fixed;

	int node;

	int degreeDifference;

	int originalDegree;

	public ModifyListEntry(final int node, final int originalDegree, final int degreeDifference, final boolean fixed)
	{
		this.originalDegree = degreeDifference;
		this.node = node;
		this.degreeDifference = degreeDifference;
		this.fixed = fixed;
	}

	@Override
	public ModifyListEntry clone()
	{
		return new ModifyListEntry(this.node, this.originalDegree, this.degreeDifference, this.fixed);
	}

	public int getDegreeDifference()
	{
		return this.degreeDifference;
	}

	public int getNode()
	{
		return this.node;
	}

	public boolean isFixed()
	{
		return this.fixed;
	}

	public void reduceDegreeDifference(final int amount)
	{
		this.degreeDifference -= amount;
	}

	@Override
	public String toString()
	{
		return "Node: " + this.node + ", raise: " + this.degreeDifference;
	}

}
