package de.vibee.kanon.tools;

import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;

import seppImpl.CompactDegreeSequence;
import de.vibee.tools.IntTripel;

public class BlockRaiseListComputer
{

	public List<IntTripel> generateBlockRaiseListBottomUp(final CompactDegreeSequence initialSeq, final CompactDegreeSequence solutionSeq)
	{
		final int initSeqCopy[] = Arrays.copyOf(initialSeq.degrees, solutionSeq.degrees.length);
		if ( initialSeq.degrees.length > solutionSeq.degrees.length )
		{
			System.out.println();
		}
		final List<IntTripel> degreeRaiseList = new LinkedList<>();
		for (int i = 0; i < initSeqCopy.length; i++)
		{
			if ( initSeqCopy[i] > solutionSeq.degrees[i] )
			{
				final int diff = initSeqCopy[i] - solutionSeq.degrees[i];
				int j = i + 1;
				while (j < initSeqCopy.length && solutionSeq.degrees[j] == 0)
				{
					++j;
				}
				degreeRaiseList.add(new IntTripel(i, j, diff));
				if ( j < initSeqCopy.length )
				{
					initSeqCopy[j] += diff - Math.max(0, solutionSeq.degrees[i] - initSeqCopy[i]);
				}
				// ++i;

			}
			// else
			// {
			// ++i;
			// }
		}
		return degreeRaiseList;
	}

}
