package de.vibee.kanon.tools;

import seppImpl.CompactDegreeSequence;
import de.vibee.kanon.data.AdjacentGraph;

public interface ErdosGallaiInterface
{

	/**
	 * Computes the feasibility of pair of degree sequence within the given graph. Computation is
	 * based on erdos gallai criterion.
	 * 
	 * @param graph
	 * @param init
	 * @param sol
	 * @param fixAll
	 * @return
	 */
	public int computeFeasibility(CompactDegreeSequence sol, boolean fixAll);

	public int computeFeasibility(CompactDegreeSequence sol, boolean fixAll, boolean getMaxDiff);

	public long getMaxRFail();

	public long getNoOfEGCalls();

	public long getTime1();

	public long getTime2();

	public long getTime3();

	public void setGraph(AdjacentGraph graph, CompactDegreeSequence init);

}
