package de.vibee.test;

import java.util.Arrays;
import java.util.List;
import java.util.Random;

import org.junit.Assert;
import org.junit.Test;

import seppImpl.CompactDegreeSequence;
import seppImpl.DegreeAnonymizer2;
import de.vibee.kanon.tools.BlockRaiseListComputer;
import de.vibee.kanon.tools.DegreeAnonymizer;
import de.vibee.tools.IntTripel;

public class GreedyGraphConstructorTest
{

	@Test
	public void testIfBlockRaiseListIsCorrect()
	{

		int counter = 0;
		while (counter < 10000)
		{
			// while (counter < 1){
			// int init [] = {5, 3, 6, 0, 3, 1, 1, 1, 1, 0};
			final int init[] = new int[50];
			for (int i = 0; i < 50; i++)
			{
				init[i] = new Random().nextInt(8);
			}
			int sumOfVertices = 0;
			for (int i = 1; i < init.length; i++)
			{
				sumOfVertices += init[i];
			}
			final int degSeq[] = new int[sumOfVertices];
			int c = 0;
			for (int i = 1; i < init.length; i++)
			{
				int j = init[i];
				while (j > 0)
				{
					degSeq[c++] = i;
					--j;
				}
			}

			new DegreeAnonymizer(null, null, 0);
			if ( DegreeAnonymizer.simpleErdosGallaiConstraint(degSeq) )
			{
				System.out.println("-------- new instance-------");
				System.out.println("Sequence length: " + degSeq.length);
				final int k = new Random().nextInt(10) + 2;
				// int k = 4;
				System.out.println("k = " + k);
				System.out.println(Arrays.toString(init));
				final CompactDegreeSequence cInit = new CompactDegreeSequence(init);

				final CompactDegreeSequence solution = new DegreeAnonymizer2(null, new CompactDegreeSequence(init), k).getAllkAnonRealSequences()
						.iterator().next();

				final List<IntTripel> degreeRaiseList = new BlockRaiseListComputer().generateBlockRaiseListBottomUp(cInit, solution);

				final int testSequence[] = new int[solution.degrees.length];
				for (int i = 0; i < init.length; i++)
				{
					testSequence[i] = init[i];
				}

				for (final IntTripel t : degreeRaiseList)
				{
					final int raise = t.getThird();
					testSequence[t.getFirst()] -= raise;
					testSequence[t.getSecond()] += raise;
					// while (raise-- > 0){
					//
					// }
				}

				boolean failure = false;
				for (int i = 0; i < testSequence.length; i++)
				{
					if ( testSequence[i] != solution.degrees[i] )
					{
						failure = true;
						System.out.println("Hier ging etwas schief");
						System.out.println("Init sequence: " + Arrays.toString(cInit.degrees));
						System.out.println("Solu sequence: " + Arrays.toString(solution.degrees));
						System.out.println("Degree Raise List: " + degreeRaiseList);
						System.out.println("Costum sequen: " + Arrays.toString(testSequence));
					}
				}

				Assert.assertTrue(!failure);
				counter++;
			}

		}

	}

	@Test
	public void testIfSolutionSizeEqualsBlockRaiseListSize()
	{

		int counter = 0;
		while (counter < 10000)
		{
			// while (counter < 1){

			// int init [] = {1, 3, 0, 0, 3, 3, 3, 0, 2, 1, 0, 0, 0, 0, 0, 0, 0,
			// 0, 0, 0}; // k > 7
			// int init [] = {1, 3, 7, 7, 1, 6, 7, 4, 5, 7, 0, 0, 0, 0, 0, 0, 0,
			// 0, 0, 0}; // k > 23
			// int init [] = {1, 0, 1, 1, 6, 1, 0, 2, 5, 3, 0, 0, 0, 0, 0, 0, 0,
			// 0, 0, 0}; // k > 9
			// int init [] = {2, 5, 1, 0, 0, 0, 2, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0,
			// 0, 0, 0}; // k > 6
			// int init [] = {3, 0, 2, 0, 1, 0, 2, 0, 1, 2, 0, 0, 0, 0, 0, 0, 0,
			// 0, 0, 0}; // k > 5
			final int init[] = new int[50];
			for (int i = 0; i < 50; i++)
			{
				init[i] = new Random().nextInt(8);
			}
			int sumOfVertices = 0;
			for (int i = 1; i < init.length; i++)
			{
				sumOfVertices += init[i];
			}
			final int degSeq[] = new int[sumOfVertices];
			int c = 0;
			int degsum = 0;
			for (int i = 1; i < init.length; i++)
			{
				int j = init[i];
				while (j > 0)
				{
					degSeq[c++] = i;
					degsum += i;
					--j;
				}
			}

			new DegreeAnonymizer(null, null, 0);
			if ( degsum % 2 == 0 && DegreeAnonymizer.simpleErdosGallaiConstraint(degSeq) )
			{
				System.out.println("-------- new instance-------");
				System.out.println("Sequence length: " + degSeq.length);
				final int k = new Random().nextInt(10) + 2;
				// int k = 4;
				System.out.println("k = " + k);
				System.out.println(Arrays.toString(init));
				final CompactDegreeSequence cInit = new CompactDegreeSequence(init);

				final int cost = new DegreeAnonymizer2(null, new CompactDegreeSequence(init), k).getSizeOfMinimumSolution();

				final CompactDegreeSequence solution = new DegreeAnonymizer2(null, new CompactDegreeSequence(init), k).getAllkAnonRealSequences()
						.iterator().next();

				final List<IntTripel> degreeRaiseList = new BlockRaiseListComputer().generateBlockRaiseListBottomUp(cInit, solution);

				int sum = 0;
				for (final IntTripel t : degreeRaiseList)
				{
					sum += t.getThird() * (t.getSecond() - t.getFirst());
				}
				if ( sum != cost )
				{
					System.out.println("Hier ging etwas schief");
					System.out.println(Arrays.toString(init));
					System.out.println("Init sequence: " + Arrays.toString(cInit.degrees));
					System.out.println("Solu sequence: " + Arrays.toString(solution.degrees));
					System.out.println("Degree Raise List: " + degreeRaiseList);
					System.out.println(sum + ", " + cost);
				}
				else
				{
					//
					System.out.println("Durchgang " + counter + " erfolgreich");
				}
				Assert.assertTrue(sum == cost);
				counter++;
			}

		}

	}

}
