package io;

import java.io.File;
import java.io.FilenameFilter;

public class ExtensionFilter implements FilenameFilter
{
	private final String ext;

	private final String[] prefix;

	public ExtensionFilter(String prefix, String extension)
	{
		this.ext = extension;
		this.prefix = prefix == null ? null : prefix.split("\\|");
	}

	@Override
	public boolean accept(File dir, String name)
	{
		boolean flag = false;
		if ( this.prefix != null )
		{
			for (final String p : this.prefix)
			{
				flag = flag || name.startsWith(p);
			}
		}

		return (this.ext != null ? name.endsWith(this.ext) : true) && (this.prefix != null ? flag : true);
	}
}
