package seppImpl.unitTests;

import java.util.Arrays;
import java.util.Iterator;

/**
 * Iterator that provides all instances of length n with max value 3*k.
 * 
 * @author sepphar
 * 
 */
public class SmallInstanceIterator implements Iterator<int[]>
{
	private final int[] arr;

	private final int max;

	private int index;

	public SmallInstanceIterator(final int n, final int k)
	{
		this.arr = new int[n];
		Arrays.fill(this.arr, 0);
		this.max = 4 * k;
		this.index = this.arr.length - 1;
	}

	@Override
	public boolean hasNext()
	{
		return this.index >= 0;
	}

	@Override
	public int[] next()
	{
		if ( !this.hasNext() )
			return null;

		this.arr[this.index]++;
		if ( this.index < this.arr.length - 1 )
		{
			Arrays.fill(this.arr, this.index + 1, this.arr.length, 0);
			this.index = this.arr.length - 1;
		}
		else
		{
			while (this.index >= 0 && this.arr[this.index] == this.max)
			{
				this.index--;
			}
		}
		return this.arr;
	}

	@Override
	public void remove()
	{
	}

}